package org.jacorb.notification.interfaces;

/*
 *        JacORB - a free Java ORB
 *
 *   Copyright (C) 1999-2004 Gerald Brose
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

import org.omg.CosEventComm.Disconnected;

/**
 * Abstraction of a ProxyPullConsumer.
 *
 * @author Alphonse Bendt
 * @version $Id: MessageSupplier.java,v 1.4 2005/08/21 13:30:01 alphonse.bendt Exp $
 */

public interface MessageSupplier {

    /**
     * pull one or more events from the Supplier
     * and hands over the pulled events to the TaskProcessor.
     */
    void runPullMessage() throws Disconnected;
    
    void destroy();
}
